// js for use with esp fw version F1.9.9
// Globals to the page greatly simplifies the start up and allows the code to
// be put here rather than in the view
// www.byvac.com
// 
// Version 0 (28 May 2016) 
//          still working on it
//
// version 0 id pre .9 where info1 does not exist as a command
var  espInfo = { valid: false, firmware:"", chipid:"", flashid:"", sysflag:"",
                mode:0, ssid: "", password:"", ip:"", gate:"", mask:"",
                port: 80, apssid: "", appassword:"", apchannel:"", apauth:"",
                version: 0};

var deviceInfo = {valid: false, id:"", fw:"", status:0};
var deviceEEPROM;  // an indexed array
var tellMe; // holds function that will be called when a function chain has completed
// =============================================================================
// Cookies  fm w3schools
// *****************************************************************************
// set a cookie
// *****************************************************************************
function setCookie(cname, cvalue, exdays) {
    var d = new Date();
    d.setTime(d.getTime() + (exdays*24*60*60*1000));
    var expires = "expires="+ d.toUTCString();
    document.cookie = cname + "=" + cvalue + "; " + expires;
}

// *****************************************************************************
// get a cookie
// *****************************************************************************
function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i = 0; i <ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') {
            c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
            return c.substring(name.length,c.length);
        }
    }
    return "";
}

// *****************************************************************************
// check for a cookie (probably not needed)
// *****************************************************************************
function checkCookie(cname) {
    var username=getCookie(cname);
    if (username!="") return true;
    else return false;
}


// =============================================================================
// ESP related
//
// *****************************************************************************
// raw input returns data, chops of ACK
// *****************************************************************************
function espData(s) {
  var valid =  s.includes("*A");
  if(s.includes("*A")) return s.slice(0,s.lastIndexOf("*A"));
  else return "";
}

// *****************************************************************************
// raw input returns data, chops of ACK
// *****************************************************************************
function deviceData(s) {
  var valid =  s.includes("A");
  if(s.includes("A")) return s.slice(0,s.lastIndexOf("A"));
  else return "";
}

// *****************************************************************************
// Request a value
// *****************************************************************************
function requestValue(url,data,callback) {
//console.log("request ip="+url+" data="+data);
  var xhttp = new XMLHttpRequest();
  var value = "";
  esp_g_value_status =0;
  xhttp.open("GET", "http://" + url + "/" + data , true);
  xhttp.timeout = 10000;
  xhttp.onreadystatechange=function(){
     if (xhttp.readyState == 4 && xhttp.status == 200) {
        callback(url,xhttp.responseText,true);
     }
  }
  xhttp.ontimeout = function() {
     callback(url,"",false);
  }
  xhttp.send();
}

// ============== get device, fill details =====================================
// espInfo[]  object array, network details
// deviceInfo[] object array, device detals - if it exists
// deviceEEPROM[] index array eeprom on device
// tellMe - function to be called at completion

// *****************************************************************************
// Startup is a chain of functions that filles the global variables with details
// about the network and device if it exists
// *****************************************************************************
function esp_startup(ip,callBack) {
    espInfo.valid = false;
    deviceInfo.valid = false;
    tellMe = callBack;   // this is the final function
    requestValue(ip,"+++info",esp_resultPart1);
}
// info is common to all releases so can get device firmware using info,
// info1 is better but only available on later versions vF1_1.9.9 onwards
function esp_resultPart1(ip,value,valid) {
    if(valid) {
        requestValue(ip,"+++info1",esp_resultPart2);
    } else {
        tellMe(ip);
    }                
}
// ip exists if hello valid
function esp_resultPart2(ip,value,valid) {
    if(valid) {
        esp_resultPart3(ip,value,valid); // process info1        
    } else {
        espInfo.version=0;
        requestValue(ip,"device/id",device_reaultPart1); // chain to device skip info
    }
}
// network information if version has it
function esp_resultPart3(ip,value,valid) {
console.log("esp_resultInfo valid="+valid+" value="+value);
    if(valid) {
        var s = espData(value); // remove Ack
        var info = s.split(",");
        espInfo.valid = true,
        espInfo.firmware = info[0];
        espInfo.chipid = info[1];
        espInfo.flashid = info[2];
        espInfo.sysflag = info[3];
        espInfo.mode = info[4];
        espInfo.ssid = info[5];
        espInfo.password = info[6];
        espInfo.ip = info[7];
        espInfo.gate = info[8];
        espInfo.mask = info[9];
        espInfo.port = info[10];
        espInfo.apssid = info[11];
        espInfo.appassword = info[12];
        espInfo.apchannel = info[13];
        espInfo.apauth = info[14]; 
        espInfo.version=1;           
        requestValue(ip,"device/id",device_reaultPart1); // chain to device
    } else {
        espInfo.valid = false
        console.log("esp_resultInfo valid2="+valid+" value="+value);
        tellMe(ip); // all done inform caller
    }
}
// device id
function device_reaultPart1(ip,value,valid) {
    if(valid) {
        var s = deviceData(value); // remove Ack
        deviceInfo.valid = true;
        deviceInfo.id = s;
        requestValue(ip,"device/fw",device_reaultPart2); // chain to 2
    } else {
        deviceInfo.valid = false;
        tellMe(ip); // all done inform caller
    }
}
// device fw
function device_reaultPart2(ip,value,valid) {
    if(valid) {
        var s = deviceData(value); // remove Ack
        deviceInfo.id = s;   // valid already set
        requestValue(ip,"relay/status",device_reaultPart3); // chain to 3
    } else {
        deviceInfo.valid = false;
        tellMe(ip);
    }
}
// relay status
function device_reaultPart3(ip,value,valid) {
    if(valid) {
        var s = deviceData(value); // remove Ack
        deviceInfo.status = s;   // valid already set
        requestValue(ip,"eeprom/r/0/12",device_reaultPart4); // chain to eeprom
    } else {
        deviceInfo.valid = false;
        tellMe(ip);
    }
}
// eeprom values
function device_reaultPart4(ip,value,valid) {
    deviceEEPROM = ""; // assume not valid
    if(valid) {
        var s = deviceData(value); // remove Ack
        deviceEEPROM = s.split(",");
        tellMe(ip);
    }
}

// ===================== set scale  ============================================
// needs 2 calls to device to set high an low values
// *****************************************************************************
// *****************************************************************************
function setScale(ip,scaleValue,callBack) {
    tellMe = callBack;
    if(scaleValue == 1) {
        deviceEEPROM[10]=0;
        requestValue(ip,"eeprom/w/9/1",do_high_scale)
    }        
    if(scaleValue == 1000) {
        deviceEEPROM[10]=3;
        requestValue(ip,"eeprom/w/9/232",do_high_scale)
    }        
    if(scaleValue == 60000) {
        deviceEEPROM[10]=234;
        requestValue(ip,"eeprom/w/9/96",do_high_scale)
    }        
}

function do_high_scale(ip,value,valid) {
    requestValue(ip,"eeprom/w/10/"+deviceEEPROM[10],tellMe);    
}

// *****************************************************************************
// sets ssid and password
// +++sta returns ssid,pass
// *****************************************************************************
function esp_setSsidPass(ip,newSSID, newPass, callBack) {
    tellMe = callBack;
    requestValue(ip,"+++sta="+newSSID+","+newPass,esp_setSsidPassR); 
}
function esp_setSsidPassR(ip,value,valid) {
    tellMe(valid);
}    
function esp_getSsidPass(ip,callBack) {
    tellMe = callBack;
    requestValue(ip,"+++sta",esp_getSsidPassR); 
}
function esp_getSsidPassR(ip,value,valid) {    
    if(valid) {
        var s = espData(value).split(",");
        tellMe(s,valid);
    } else {
        tellMe(value,valid);
    }    
}    

// *****************************************************************************
// sets ip,gateway and mask
// +++ip returns ip,gw,netmask
// *****************************************************************************
function esp_setNewIP(ip,newIP, newGw, newMask, callBack) {
    tellMe = callBack;
    requestValue(ip,"+++ip="+newIP+","+newGw+","+newMask,esp_setNewIPR); 
}
function esp_setNewIPR(ip,value,valid) {
    tellMe(valid);
}    

// *****************************************************************************
// gets, sets ip address
// +++ip returns ip,gateway,mask
// GET:
//  newValue = ""
//  return "the value"  or ""
// SET:
//  newValue = "some value"
//  retirn "ok" or ""
// *****************************************************************************
function esp_ip(ip,newValue) {
    var esp = getValue(ip,"+++ip");
    if(esp.valid) {
        var ipconfig = esp.value.split(",");
        var ip = sta[0];
        var gate = sta[1];
        var mask = sta[2];
        // get or set
        if(newValue.length == 0) {
            return ip;
        } else {
            esp = getValue(ip,"+++ip="+newValue+","+gate+","+mask);
            if(esp.valid) {
                return "ok";
            } else {
                return "";
            }
        }
    } else {
        // error in getting value
        return ""
    }
}

// *****************************************************************************
// gets, sets ip gateway
// +++ip returns ip,gateway,mask
// GET:
//  newValue = ""
//  return "the value"  or ""
// SET:
//  newValue = "some value"
//  retirn "ok" or ""
// *****************************************************************************
function esp_gate(ip,newValue) {
    var esp = getValue(ip,"+++ip");
    if(esp.valid) {
        var ipconfig = esp.value.split(",");
        var ip = ipconfig[0];
        var gate = ipconfig[1];
        var mask = ipconfig[2];
        // get or set
        if(newValue.length == 0) {
            return gate;
        } else {
            esp = getValue(ip,"+++ip="+ip+","+newValue+","+mask);
            if(esp.valid) {
                return "ok";
            } else {
                return "";
            }
        }
    } else {
        // error in getting value
        return ""
    }
}

// *****************************************************************************
// gets, sets esp parameter, works for single values
// +++port returns number
// GET:
//  newValue = ""
//  return "the value"  or ""
// SET:
//  newValue = "some value"
//  return "ok" or ""
// *****************************************************************************
function esp_cmd(ip,cmd,newValue) {
    var esp = getValue(ip,"+++"+cmd);
    if(esp.valid) {
        // get or set
        if(newValue.length == 0) {
            return esp.value;
        } else {
            esp = getValue(ip,"+++"+xmd+"="+newValue);
            if(esp.valid) {
                return "ok";
            } else {
                return "";
            }
        }
    } else {
        // error in getting value
        return ""
    }
}

// *****************************************************************************
// gets, sets port
// +++port returns number
// GET:
//  newValue = ""
//  return "the value"  or ""
// SET:
//  newValue = "some value"
//  return "ok" or ""
// *****************************************************************************
function esp_port(ip,newValue) {
    var esp = getValue(ip,"+++port");
    if(esp.valid) {
        // get or set
        if(newValue.length == 0) {
            return esp.value;
        } else {
            esp = getValue(ip,"+++port="+newValue);
            if(esp.valid) {
                return "ok";
            } else {
                return "";
            }
        }
    } else {
        // error in getting value
        return ""
    }
}

